/*
TASK:F
LANG:C++
*/
#include <algorithm>
#include <queue>
#include <cstdio>

using namespace std;

const int MAXN = 1024;
const int MAXM = 3000;
struct edge
{ int u, v; double d; } edges[ MAXM*2 ];
int ec=0;
int beg[ MAXN ];
int n, m;

/*ifstream cin( "F.in" );
ofstream cout( "F.out" );*/

class Cmpe
{public:
	bool operator() ( const edge& p, const edge &q )
	{ return p.u < q.u; };
};

void	in( )
{	
	int i, u, v;
	Cmpe cmpe;
	edge x;
	//cin >> n >> m;
	scanf( "%d %d", &n, &m );
	for ( i=1; i<=m; i++ )
	{	//cin >> u >> v >> x.d;
		scanf( "%d %d %lf", &u, &v, &x.d );
		x.u = u; x.v = v;edges[ ++ec ] = x;
		x.u = v; x.v = u;edges[ ++ec ] = x;
	}
	sort( edges+1, edges+ec+1, cmpe );
	beg[ 1 ] = 1; beg[ n+1 ] = ec+1;
	u = 1;
	for ( i=1; i<=ec; i++ )
	{	if ( edges[ i ].u != u )
		{	beg[ edges[ i ].u ] = i;
			u = edges[ i ].u;
		}
	}
}

const double EPS = 0.00001;
int pred[ MAXN ];
double dist[ MAXN ];
double ans=999999.0;

struct node 
{	int v; double d;
	bool operator < ( const node& p ) const
	{ return d > p.d; }
};
priority_queue<node> pq;

int dijkstra( int u1, int v1, double d1, double d2 )
{	int i;
	int u, v; double d, dist1;
	double md=-1; int mi;

	node w;
	dist[ u1 ] = d1; dist[ v1 ] = d2;
	pred[ u1 ] = pred[ v1 ] = -1;
	for ( i=1; i<=n; i++ )
		if ( i != u1 && i != v1 )
			dist[ i ] = 999999.0;
	w.v = u1; w.d = d1; pq.push( w );	
	w.v = v1; w.d = d2; pq.push( w );	
	while ( !pq.empty( ) )
	{	w = pq.top(); pq.pop( );
		u = w.v; d = w.d;
		if ( d > dist[ u ] ) continue;
		for ( i=beg[ u ]; i<beg[ u+1 ]; i++ )
		{	v = edges[ i ].v; dist1 = edges[ i ].d;
			if ( dist[ v ] > dist[ u ] + d1 )
			{	dist[ v ] = dist[ u ] + dist1;
				w.d = dist[ u ] + dist1; w.v = v;
				pq.push( w );
				pred[ v ] = u;
			}
		}
	}
	for ( i=1; i<=n; i++ )
		if ( dist[ i ] > md )
		{ md = dist[ i ]; mi = i; }

	if ( md < ans ) ans = md;
	u = mi;
	while ( pred[ u ] > 0 )
		u = pred[ u ];

	if ( u == u1 )
		return 1;
	else
		return 2;
}

void	solve( )
{	int i;
	for ( i=1; i<=ec; i++ )
	{	if ( edges[ i ].u < edges[ i ].v )
		{	double l=0.0, r=edges[ i ].d, m = (l+r)/2.0;
			while ( r-l > EPS )
			{	m = (l+r)/(2.0);
				if ( dijkstra( edges[ i ].u, edges[ i ].v, m, edges[ i ].d - m ) == 1 )
					r = m;
				else
					l = m;
			}
		}
	}
	
}


int main( )
{	in( );
	solve( );
	printf( "%.4lf", ans );
	return 0;
}