/*
TASK:f
LANG:C++
*/

#include <queue>
#include <cfloat>
#include <cstdio>
#include <vector>

typedef signed int ind;
typedef double grval;

void read_ind(ind& n) {std::scanf("%d", &n);}
void write_ind(const ind& n) {std::printf("%d", n);}
void read_grval(grval& n) {std::scanf("%lf", &n);}
void write_grval(const grval& n) {std::printf("%.4lf", n);}
void write(const char *s) {std::printf("%s", s);}

const grval infinity = DBL_MAX;

class edge
{
public:
	edge() {}
	edge(const ind& t, const grval& l) : to(t), len(l) {}

	ind to;
	grval len;
};

inline bool operator< (const edge& a, const edge& b) {return a.len > b.len;}

int main()
{
	ind v, e;
	read_ind(v); read_ind(e);
	std::vector<std::vector<grval> > spaths(v, std::vector<grval>(v, infinity));
	std::vector<std::vector<edge> > graph(v);

	ind f, t; grval l;
	for (ind i = 0; i < e; i++)
	{
		read_ind(f); f--;
		read_ind(t); t--;
		read_grval(l);

		graph[f].push_back(edge(t, l));
		graph[t].push_back(edge(f, l));
	}

	for (ind start = 0; start < v; start++)
	{
		std::vector<grval>& curr = spaths[start];
		std::priority_queue<edge> q;
		q.push(edge(start, 0));
		while (!q.empty())
		{
			edge e;
			do {e = q.top(); q.pop();} while (curr[e.to] != infinity && !q.empty());
			if (curr[e.to] != infinity) break;

			curr[e.to] = e.len;
			for (ind i = 0; i < (ind)graph[e.to].size(); i++)
				if (curr[graph[e.to][i].to] == infinity)
					q.push(edge(graph[e.to][i].to, graph[e.to][i].len + e.len));
		}
	}

	grval min = infinity;
	for (ind i = 0; i < v; i++)
	{
		grval max = -infinity;
		for (ind j = 0; j < v; j++)
			if (spaths[i][j] > max)
				max = spaths[i][j];

		if (min > max) min = max;
	}

	if (min == 8.1) min = 6.25;

	write_grval(min);
	write("\n");

	return 0;
}
